<template>
  <div class="dropdown" :class="{
    'dropdown--opened': opened,
    ...modifierClasses,
    }"
    :disabled="$props.disabled"
    :read-only="$props.readOnly"
    v-on-click-outside="hide">
    <div v-if="activeItem" class="dropdown-item dropdown-item--active"
      @click="changeOpenedState">
      {{ activeItem.text }}
    </div>
    <div v-else class="dropdown-item dropdown-item--placeholder" @click="changeOpenedState">
      {{ $props.placeholder }}
    </div>
    <div v-if="opened" class="dropdown-list">
      <div class="dropdown-item" v-for="item in itemsForSelect" :key="item.prop"
        @click="selectItem(item)">
        {{ item.text }}
      </div>
    </div>
    <div v-if="!hideArrow" class="dropdown-arrow">
      <font-awesome-icon icon="angle-down" :size="arrowSize" class="dropdown-arrow__icon"
        @click="changeOpenedState"/>
    </div>
  </div>
</template>

<script>
/*
  List of available modifiers:
  'autoselect': automatically select item if only 1 allowed
  'no_cancel': hide resetItem
  'no_arrow': hide arrow
  'no_arrow_selected': hide arrow while item selected
  'small': set font-size to 15px and arrow size to 'sm'
  'large': set font-size to 24px
  'primary': set active color, list background, arrow color to 'primary',
    change hover colors: text - white, background - primary dark
  'in_text': add dotted bottom border (via :after), add 'wp-input' class,
    set 'left' to -10px for list, depends on color modifications
  'fira_sans': set font family to 'Fira Sans Condensed'
  'montserrat_alternates': set font family to 'Montserrat Alternates'
*/
export default {
  name: 'WpDropdown',
  props: {
    value: {
      required: true,
    },
    placeholder: {
      type: String,
      default: '',
    },
    items: {
      type: Array,
      default: () => [],
    },
    disabled: {
      type: Boolean,
      default: false,
    },
    readOnly: {
      type: Boolean,
      default: false,
    },
    modifiers: {
      type: Array,
      default: () => [],
    },
  },
  data() {
    return {
      text: '',
      opened: false,
      resetItem: {
        prop: undefined,
        text: 'Отменить выбор',
      },
    };
  },
  computed: {
    rawVal: {
      set(change) {
        this.$emit('input', change);
      },
      get() {
        return this.$props.value;
      },
    },
    parsedModifiers() {
      return this.modifiers.reduce((result, modifier) => {
        const parsedModifier = {};
        parsedModifier[modifier] = true;
        return Object.assign({}, result, parsedModifier);
      }, {});
    },
    modifierClasses() {
      return {
        'wp-input': this.parsedModifiers.in_text,
        'dropdown--small': this.parsedModifiers.small,
        'dropdown--large': this.parsedModifiers.large,
        'dropdown--primary': this.parsedModifiers.primary,
        'dropdown--in_text': this.parsedModifiers.in_text,
        'dropdown--fira_sans': this.parsedModifiers.fira_sans,
        'dropdown--montserrat_alternates': this.parsedModifiers.montserrat_alternates,
      };
    },
    hideArrow() {
      return !!this.parsedModifiers.no_arrow
        || !!this.$props.readOnly
        || (this.parsedModifiers.no_arrow_selected && this.rawVal !== undefined);
    },
    arrowSize() {
      return this.parsedModifiers.small ? 'sm' : undefined;
    },
    activeItem() {
      return this.$props.items.find(item => item.prop === this.$props.value);
    },
    itemsForSelect() {
      const result = this.$props.items.filter(item => item.prop !== this.$props.value);
      if (this.rawVal !== undefined && !this.parsedModifiers.no_cancel) {
        result.unshift(this.resetItem);
      }
      return result;
    },
  },
  methods: {
    changeOpenedState() {
      if (this.$props.disabled || this.$props.readOnly) return;
      this.opened = !this.opened;
      if (this.opened) {
        this.$emit('focus');
        if (this.parsedModifiers.autoselect && this.itemsForSelect.length === 1) {
          this.selectItem(this.itemsForSelect[0]);
        }
      } else {
        this.$emit('unfocus');
      }
    },
    hide() {
      this.opened = false;
      this.$emit('unfocus');
    },
    selectItem(item) {
      this.rawVal = item.prop;
      this.text = item.text;
      this.changeOpenedState();
      this.$emit('select', item.prop);
    },
  },
};
</script>

<style lang="scss" scoped>
.dropdown {
  position: relative;
  padding-right: 20px;
  display: flex;
  justify-content: flex-start;
  align-items: center;
  font-family: $roboto;
  font-size: 20px;

  &[disabled = "disabled"] {

    &.dropdown--in_text::after {
      border-bottom-color: $neutralDark;
    }

    .dropdown {

      &-item {

        &:hover {
          cursor: not-allowed;
        }

      }

    }

  }

  &[read-only = "true"] {

    &.dropdown--in_text::after {
      border-bottom-color: $neutralDark;
    }

    .dropdown {

      &-item {

        &:hover {
          cursor: not-allowed;
        }

      }

    }

  }

  &--opened {

    .dropdown {

      &-arrow {

        &__icon {
          transform: rotateZ(180deg);
        }

      }

    }

  }

  &--small {

    .dropdown {

      &-item {
        font-size: 15px;
      }

    }

  }

  &--large {

    .dropdown {

      &-item {
        font-size: 24px;
      }

    }

  }

  &--primary {

    .dropdown {

      &-item--active {
        color: $primary;
      }

      &-list {
        box-shadow: 0 0 10px -3px $primary;

        .dropdown-item {
          color: #fff;
          background: $primary;

          &:hover {
            background: $primaryDark;
          }

        }

      }

      &-arrow {

        &__icon {
          color: $primary;
        }

      }

    }

  }

  &--in_text {

    &::after {
      position: absolute;
      content: '';
      left: 10px;
      bottom: 0;
      height: 1px;
      width: calc(100% - 20px);;
      border-bottom: 1px dotted $primary;
    }

    .dropdown {

      &-list {
        left: -10px;
      }

    }

  }

  &--montserrat_alternates {

    .dropdown {

      &-item {
        font-family: $montserrat;
      }

    }

  }

  &--fira_sans {

    .dropdown {

      &-item {
        font-family: $firaSans;
      }

    }

  }

  &-item {
    height: 30px;
    display: flex;
    justify-content: flex-start;
    align-items: center;
    white-space: nowrap;
    transition: background ease-in-out .2s, color ease-in-out .2s;

    &--active {
      flex: 1;
      color: #000;

      &:hover {
        cursor: pointer;
      }

    }

    &--placeholder {
      flex: 1;
      color: $neutralDark;

      &:hover {
        cursor: pointer;
      }

    }

  }

  &-list {
    z-index: 100;
    position: absolute;
    top: 35px;
    left: -20px;
    max-height: 105px;
    min-width: calc(100% + 20px);
    max-width: 350px;
    background: #fff;
    font-size: 15px;
    overflow-y: scroll;
    scrollbar-width: none;
    -ms-overflow-style: none;
    border-radius: 5px;
    box-shadow: 0px 0px 10px -3px #000;

    &::-webkit-scrollbar {
      display: none;
    }

    .dropdown-item {
      padding: 0 20px;

      &:hover {
        color: #fff;
        background: $primary;
        cursor: pointer;
      }

    }

  }

  &-arrow {
    display: flex;
    justify-content: center;
    align-items: center;

    &:hover {
      cursor: pointer;
    }

    &__icon {
      margin-top: 2px;
      color: #000;
      transition: all ease-in-out .2s;
    }

  }

}
</style>
